VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsFiles"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Dim pFiles() As String

Public Function AddFile(sFile As String) As Long

    Dim Index As Long
    
    ' Retrive a valid index
    Index = Count + 1

    ' Reallocate space
    ReDim Preserve pFiles(Index)
    
    ' Set this element to the file
    pFiles(Index) = sFile
    
    ' Return the created index
    AddFile = Index

End Function

Public Sub RemoveFile(Index As Long)

    Dim Tell As Long
    
    For Tell = Index To Count - 1
        pFiles(Tell) = pFiles(Tell + 1)
    Next
    
    If Count > 0 Then
        ReDim Preserve pFiles(Count - 1)
    Else
        Erase pFiles
    End If

End Sub

Public Sub ClearAll()

    Erase pFiles

End Sub

Public Sub SaveData(sFile As String)

    Dim Free As Long, lngCount As Long
    
    Free = FreeFile

    If Dir(sFile) <> "" Then
        Kill sFile
    End If

    Open sFile For Binary As #Free
        
        ' Get the amout of files
        lngCount = Count
        
        ' Save it
        Put #Free, , lngCount
        
        ' Do not try to load the data if the total amout of files is nothing
        If Count >= 0 Then
            Put #Free, , pFiles
        End If
        
    Close #Free

End Sub

Public Sub LoadData(sFile As String)

    Dim Free As Long, lngCount As Long
        
    Free = FreeFile

    Open sFile For Binary As #Free
        Get #Free, , lngCount
        
        ' See if there is saved some files
        If lngCount >= 0 Then
            ReDim pFiles(lngCount)
            Get #Free, , pFiles
        Else
            ' Clear the files
            Erase pFiles
        End If
        
    Close #Free

End Sub

Public Sub AddToList(ListBox As ListBox)

    Dim Tell As Long
    
    ' Clear the listbox
    ListBox.Clear
    
    If Count >= 0 Then
        For Tell = LBound(pFiles) To UBound(pFiles)
            ListBox.AddItem pFiles(Tell)
        Next
    End If

End Sub

Public Function IsFile(ByVal Index As Long) As Boolean

    IsFile = CBool(Index >= LBound(pFiles) And Index <= UBound(pFiles))

End Function

Public Property Get Count() As String

    If (Not Not pFiles) Then
        Count = UBound(pFiles)
    Else
        Count = -1
    End If
    
End Property

Public Property Get File(ByVal Index As Long) As String

    If IsFile(Index) Then
        File = pFiles(Index)
    End If
    
End Property

Public Property Let File(ByVal Index As Long, ByVal vNewValue As String)
    
    If IsFile(Index) Then
        pFiles(Index) = vNewValue
    End If

End Property
